<?php
/**
 * @package    Dmitry Lysohor
 * @subpackage Graphics
 * @copyright  Copyright (C) 2010. All rights reserved.
 * @link http://htmlcoderhelper.com
 * @license    GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * @package		Dmitry Lysohor
 * @subpackage	Graphics
 */
class GraphicsControllerTimeframe extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		$this->registerTask( 'add'  ,     'edit' );
	}

    /**
	 * display method of Timeframe view
	 * @return void
	 **/
	function display()
    {
        parent::display();
    }
	
	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		JRequest::setVar( 'view', 'timeframe' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		global $mainframe;
		
		$model = $this->getModel('timeframes');

		if ($model->store()) {
			$msg = JText::_( 'Error saving!' );
		} else {
			$msg = JText::_( 'Error saving' );
		}

		$link = 'index.php?option=com_graphics&task=timeframes&view=timeframes';
		$mainframe->redirect($link);
	}
	
	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		global $mainframe;
		
		$model = $this->getModel('timeframes');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or More Timeframes Could not be Deleted' );
		} else {
			$msg = JText::_( 'Timeframe has been deleted' );
		}

		$mainframe->redirect('index.php?option=com_graphics&task=timeframes&view=timeframes');
	}
	
	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		global $mainframe;
		$msg = JText::_( 'Operation aborted' );
		$mainframe->redirect('index.php?option=com_graphics&task=timeframes&view=timeframes');
	}
}
?>