<?php
/**
 * @package    Dmitry Lysohor
 * @subpackage Graphics
 * @copyright  Copyright (C) 2010. All rights reserved.
 * @link http://htmlcoderhelper.com
 * @license    GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * @package		Dmitry Lysohor
 * @subpackage	Graphics
 */
class GraphicsModelTimeframes extends JModel
{
    /**
     * Timeframes data array
     *
     * @var array
     */
    var $_data;

    /**
     * Return query
     * @return string query used to retrieve rows from a database
     */
    function _buildQuery()
    {
        $query = ' SELECT * '
            . ' FROM #__graphics_timeframe '
        ;
        return $query;
    }

    /**
     * Getting data 
     * @return array of data
     */
    function getData()
    {
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query );
        }

        return $this->_data;
    }
	
	/**
	 * Method to store a record
	 *
	 * @access    public
	 * @return    boolean    True on success
	 */
	function store()
	{
		$row = $this->getTable();

		$data = JRequest::get( 'post' );
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}
	
	/**
	 * Method to delete record(s)
	 *
	 * @access    public
	 * @return    boolean    True on success
	 */
	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row = $this->getTable();

		foreach($cids as $cid) {
			if (!$row->delete( $cid )) {
				$this->setError( $row->getErrorMsg() );
				return false;
			}
		}                        

		return true;
	}
}

?>