<?php
/**
 * @package    Dmitry Lysohor
 * @subpackage Graphics
 * @copyright  Copyright (C) 2010. All rights reserved.
 * @link http://htmlcoderhelper.com
 * @license    GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

require_once( JPATH_COMPONENT.DS.'models'.DS.'timeframes.php' );

/**
 * @package		Dmitry Lysohor
 * @subpackage	Graphics
 */
class GraphicsViewGraphic extends JView
{
    /**
	 * display method of Graphic view
	 * @return void
	 **/
	function display($tpl = null)
	{

		$graphic        = $this->get('Data');
		$isNew        = ($graphic->id < 1);

		$text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
		JToolBarHelper::title(   JText::_( 'graphicsmanager' ).': <small><small>[ ' . $text.' ]</small></small>' );
		JToolBarHelper::save();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		
		$timeframesModel = new GraphicsModelTimeframes();
		
		$timeframes = $timeframesModel->getData();
		
		$this->assignRef('timeframes',     $timeframes);		
		$this->assignRef('graphic',        $graphic);
		parent::display($tpl);
	}
}

?>