<?php
/**
 * @package    Dmitry Lysohor
 * @subpackage Graphics
 * @copyright  Copyright (C) 2010. All rights reserved.
 * @link http://htmlcoderhelper.com
 * @license    GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

require_once( JPATH_COMPONENT.DS.'models'.DS.'graphic.php' );

/**
 * @package		Dmitry Lysohor
 * @subpackage	Graphics
 */
class GraphicsViewPoints extends JView
{
    /**
     * Points view display method
     * @return void
     **/
    function display($tpl = null)
    {
		global $mainframe, $option;
		
        JToolBarHelper::title(   JText::_( 'pointsmanager' ), 'generic.png' );
        JToolBarHelper::deleteList();
        JToolBarHelper::editListX();
        JToolBarHelper::addNewX();
		
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

        // Get data from the model
        $items        = $this->get( 'Data');
		
		//Get Graphic name instead ID
		$graphicModel = new GraphicsModelGraphic();
		//$graphic = $graphicModel->getData();
		//print_r($items);
		$newItems = array();
		foreach($items as $id => $item){
			//echo $id.'<br/>';
			$newItems[$id] = $item;
			if ($item->pointgraphic != '') {
				$graphicModel->setId($item->pointgraphic);
				$graphicData = $graphicModel->getData();
				$items[$id]->pointgraphic = $graphicData->name;
			}
		}
		
		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		
		// search filter
		$lists['search']= $search;
		
        $this->assignRef('items',        $items);
		$this->assignRef('lists',		$lists);

        parent::display($tpl);
    }
}

?>